"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/trace.ts
var trace_exports = {};
__export(trace_exports, {
  ELYSIA_TRACE: () => ELYSIA_TRACE,
  createTracer: () => createTracer
});
module.exports = __toCommonJS(trace_exports);
var ELYSIA_TRACE = Symbol("ElysiaTrace");
var createProcess = () => {
  const { promise, resolve } = Promise.withResolvers();
  const { promise: end, resolve: resolveEnd } = Promise.withResolvers();
  return [
    promise,
    (v) => {
      resolve({
        ...v,
        end
      });
      return () => {
        resolveEnd(performance.now());
      };
    }
  ];
};
var createTracer = (callback) => {
  return (context) => {
    const [request, resolveRequest] = createProcess();
    const [parse, resolveParse] = createProcess();
    const [transform, resolveTransform] = createProcess();
    const [beforeHandle, resolveBeforeHandle] = createProcess();
    const [handle, resolveHandle] = createProcess();
    const [afterHandle, resolveAfterHandle] = createProcess();
    const [error, resolveError] = createProcess();
    const [response, resolveResponse] = createProcess();
    callback({
      context,
      // @ts-ignore
      request,
      // @ts-ignore
      parse,
      // @ts-ignore
      transform,
      // @ts-ignore
      beforeHandle,
      // @ts-ignore
      handle,
      // @ts-ignore
      afterHandle,
      // @ts-ignore
      error,
      // @ts-ignore
      response
    });
    return {
      request: resolveRequest,
      parse: resolveParse,
      transform: resolveTransform,
      beforeHandle: resolveBeforeHandle,
      handle: resolveHandle,
      afterHandle: resolveAfterHandle,
      error: resolveError,
      response: resolveResponse
    };
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ELYSIA_TRACE,
  createTracer
});
