// src/trace.ts
var ELYSIA_TRACE = Symbol("ElysiaTrace");
var createProcess = () => {
  const { promise, resolve } = Promise.withResolvers();
  const { promise: end, resolve: resolveEnd } = Promise.withResolvers();
  return [
    promise,
    (v) => {
      resolve({
        ...v,
        end
      });
      return () => {
        resolveEnd(performance.now());
      };
    }
  ];
};
var createTracer = (callback) => {
  return (context) => {
    const [request, resolveRequest] = createProcess();
    const [parse, resolveParse] = createProcess();
    const [transform, resolveTransform] = createProcess();
    const [beforeHandle, resolveBeforeHandle] = createProcess();
    const [handle, resolveHandle] = createProcess();
    const [afterHandle, resolveAfterHandle] = createProcess();
    const [error, resolveError] = createProcess();
    const [response, resolveResponse] = createProcess();
    callback({
      context,
      // @ts-ignore
      request,
      // @ts-ignore
      parse,
      // @ts-ignore
      transform,
      // @ts-ignore
      beforeHandle,
      // @ts-ignore
      handle,
      // @ts-ignore
      afterHandle,
      // @ts-ignore
      error,
      // @ts-ignore
      response
    });
    return {
      request: resolveRequest,
      parse: resolveParse,
      transform: resolveTransform,
      beforeHandle: resolveBeforeHandle,
      handle: resolveHandle,
      afterHandle: resolveAfterHandle,
      error: resolveError,
      response: resolveResponse
    };
  };
};
export {
  ELYSIA_TRACE,
  createTracer
};
